"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.startServer = void 0;
const theme_language_server_common_1 = require("@shopify/theme-language-server-common");
const browser_1 = require("vscode-languageserver/browser");
const disposable = (dispose) => ({ dispose });
__exportStar(require("@shopify/theme-language-server-common"), exports);
// This is where you do the worker.postMessage stuff?
// Or is this where we accept the worker.postMessage stuff?
// Yeah I think this is where you _accept_ the worker.postMessage stuff
function startServer(worker, dependencies) {
    // This is just ugly glue code that basically pipes the messages from the
    // worker connection to the library. They have a very specific interface
    // we need to map to, so that's what we're doing here.
    const reader = {
        onError(_listener) {
            return disposable(() => { });
        },
        onClose(_listener) {
            return disposable(() => { });
        },
        onPartialMessage(_listener) {
            return disposable(() => { });
        },
        dispose() { },
        listen(callback) {
            const onMessage = (message) => callback(message.data);
            worker.addEventListener('message', onMessage);
            return disposable(() => worker.removeEventListener('message', onMessage));
        },
    };
    // Glue code between our code and the vscode liquid language server
    // It exists to map our messages to postMessage.
    const writer = {
        onError(_listener) {
            return disposable(() => { });
        },
        onClose(_listener) {
            return disposable(() => { });
        },
        dispose() { },
        end() { },
        async write(msg) {
            worker.postMessage(msg);
        },
    };
    const connection = (0, browser_1.createConnection)(reader, writer);
    (0, theme_language_server_common_1.startServer)(connection, dependencies);
}
exports.startServer = startServer;
//# sourceMappingURL=index.js.map